Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2715)
@@ -16,6 +16,4 @@
    USE trc
    USE sms_pisces
-   USE lbclnk
-   USE lib_mpp
    
    USE p4zint          ! 
@@ -65,12 +63,18 @@
       !!              - ...
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztrpis => wrk_3d_1   ! used for pisces sms trends
+      !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
       INTEGER ::   jnt, jn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrpis   ! used for pisces sms trends
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
       IF( kt == nit000 )   CALL trc_sms_pisces_init    ! Initialization (first time-step only)
+
+      IF( wrk_in_use(3,1) )  THEN
+        CALL ctl_stop('trc_sms_pisces : requested workspace array unavailable.')  ;  RETURN
+      ENDIF
 
       IF( ndayflxtr /= nday_year ) THEN      ! New days
@@ -111,4 +115,5 @@
             CALL trd_mod_trc( ztrpis, jn, jptra_trd_sms, kt )   ! save trends
           END DO
+          DEALLOCATE( ztrpis )
       END IF
 
@@ -122,4 +127,6 @@
          !
       ENDIF
+
+      IF( wrk_not_released(3,1) ) CALL ctl_stop('trc_sms_pisces : failed to release workspace array.') 
 
    END SUBROUTINE trc_sms_pisces
Index: trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2715)
@@ -17,5 +17,4 @@
    USE sedarr
    USE iom
-   USE in_out_manager  ! I/O manager
 
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2715)
@@ -10,5 +10,4 @@
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trc_adv      : compute ocean tracer advection trend
@@ -26,15 +25,15 @@
    USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
    USE ldftra_oce      ! lateral diffusion coefficient on tracers
-   USE in_out_manager  ! I/O manager
-   USE prtctl_trc          ! Print control
+   USE prtctl_trc      ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   trc_adv    ! routine called by step module
+   PUBLIC   trc_adv          ! routine called by step module
+   PUBLIC   trc_adv_alloc    ! routine called by nemogcm module
 
    INTEGER ::   nadv   ! choice of the type of advection scheme
-   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
-      !                                ! except at nit000 (=rdttra) if neuler=0
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::   r2dt  ! vertical profile time-step, = 2 rdttra
+   !                                                    ! except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -46,6 +45,17 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
+
+   INTEGER FUNCTION trc_adv_alloc()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_adv_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( r2dt(jpk), STAT=trc_adv_alloc )
+
+      IF( trc_adv_alloc /= 0 ) CALL ctl_warn('trc_adv_alloc : failed to allocate array.')
+
+   END FUNCTION trc_adv_alloc
+
 
    SUBROUTINE trc_adv( kt )
@@ -57,11 +67,16 @@
       !! ** Method  : - Update the tracer with the advection term following nadv
       !!----------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zun => wrk_3d_4, zvn => wrk_3d_5, zwn => wrk_3d_6   ! effective velocity
       !!
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-      !
-      INTEGER :: jk 
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zun, zvn, zwn   ! effective velocity
-      CHARACTER (len=22) :: charout
-      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !
+      INTEGER ::   jk 
+      CHARACTER (len=22) ::   charout
+      !!----------------------------------------------------------------------
+      !
+      IF( wrk_in_use(3, 4,5,6) ) THEN
+         CALL ctl_stop('trc_adv : requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
 
       IF( kt == nit000 )   CALL trc_adv_ctl          ! initialisation & control of options
@@ -80,7 +95,7 @@
       DO jk = 1, jpkm1
          !                                                ! eulerian transport only
-         zun(:,:,jk) = e2u(:,:) * fse3u(:,:,jk) * un(:,:,jk)
-         zvn(:,:,jk) = e1v(:,:) * fse3v(:,:,jk) * vn(:,:,jk)
-         zwn(:,:,jk) = e1t(:,:) * e2t(:,:)      * wn(:,:,jk)
+         zun(:,:,jk) = e2u  (:,:) * fse3u(:,:,jk) * un(:,:,jk)
+         zvn(:,:,jk) = e1v  (:,:) * fse3v(:,:,jk) * vn(:,:,jk)
+         zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
          !
       END DO
@@ -125,4 +140,6 @@
                                             CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       END IF
+      !
+      IF( wrk_not_released(3, 4,5,6) ) CALL ctl_stop('trc_adv : failed to release workspace arrays.')
       !
    END SUBROUTINE trc_adv
@@ -171,4 +188,5 @@
       !
    END SUBROUTINE trc_adv_ctl
+   
 #else
    !!----------------------------------------------------------------------
@@ -181,4 +199,5 @@
    END SUBROUTINE trc_adv
 #endif
+
   !!======================================================================
 END MODULE trcadv
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2715)
@@ -29,8 +29,10 @@
    PRIVATE
 
-   PUBLIC trc_dmp      ! routine called by step.F90
+   PUBLIC trc_dmp            ! routine called by step.F90
+   PUBLIC trc_dmp_alloc      ! routine called by nemogcm.F90
 
    LOGICAL , PUBLIC, PARAMETER ::   lk_trcdmp = .TRUE.   !: internal damping flag
-   !                             !!* Namelist namtrc_dmp : passive tracer newtonian damping *
+
+   !                                !!* Namelist namtrc_dmp : passive tracer newtonian damping *
    INTEGER  ::   nn_hdmp_tr =   -1   ! = 0/-1/'latitude' for damping over passive tracer
    INTEGER  ::   nn_zdmp_tr =    0   ! = 0/1/2 flag for damping in the mixed layer
@@ -40,5 +42,5 @@
    INTEGER  ::   nn_file_tr =    2   ! = 1 create a damping.coeff NetCDF file 
 
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   restotr   ! restoring coeff. on tracers (s-1)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   restotr   ! restoring coeff. on tracers (s-1)
 
    !! * Substitutions
@@ -47,8 +49,18 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Header: /home/opalod/NEMOCVSROOT/NEMO/TOP_SRC/TRP/trcdmp.F90,v 1.11 2006/09/01 14:03:49 opalod Exp $ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
+
+   INTEGER FUNCTION trc_dmp_alloc()
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_dmp_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( restotr(jpi,jpj,jpk) , STAT=trc_dmp_alloc )
+      !
+      IF( trc_dmp_alloc /= 0 )   CALL ctl_warn('trc_dmp_alloc: failed to allocate array')
+      !
+   END FUNCTION trc_dmp_alloc
+
 
    SUBROUTINE trc_dmp( kt )
@@ -161,5 +173,5 @@
       !!
       !! ** Method  :   read the nammbf namelist and check the parameters
-      !!      called by trc_dmp at the first timestep (nit000)
+      !!              called by trc_dmp at the first timestep (nit000)
       !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2715)
@@ -27,7 +27,4 @@
    USE trdtra
    USE prtctl_trc      ! Print control
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! distribued memory computing library
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2715)
@@ -3,5 +3,4 @@
    !!                       ***  MODULE  trcnxt  ***
    !! Ocean passive tracers:  time stepping on passives tracers
-   !!======================================================================
    !!======================================================================
    !! History :  7.0  !  1991-11  (G. Madec)  Original code
@@ -27,5 +26,4 @@
    !!   trc_nxt     : time stepping on passive tracers
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce_trc         ! ocean dynamics and tracers variables
    USE trc             ! ocean passive tracers variables
@@ -43,15 +41,26 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC trc_nxt          ! routine called by step.F90
+   PUBLIC   trc_nxt          ! routine called by step.F90
+   PUBLIC   trc_nxt_alloc    ! routine called by nemogcm.F90
 
-  REAL(wp), DIMENSION(jpk) ::   r2dt
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::   r2dt
+
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
+CONTAINS
 
-CONTAINS
+   INTEGER FUNCTION trc_nxt_alloc()
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_nxt_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( r2dt(jpk), STAT=trc_nxt_alloc )
+      !
+      IF( trc_nxt_alloc /= 0 )   CALL ctl_warn('trc_nxt_alloc : failed to allocate array')
+      !
+   END FUNCTION trc_nxt_alloc
+
 
    SUBROUTINE trc_nxt( kt )
@@ -79,7 +88,6 @@
       !! ** Action  : - update trb, trn
       !!----------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
-      !! * Local declarations
+      !
       INTEGER  ::   jk, jn   ! dummy loop indices
       REAL(wp) ::   zfact            ! temporary scalar
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2715)
@@ -17,5 +17,4 @@
    USE trdmod_oce
    USE trdtra
-   USE lib_mpp
    USE prtctl_trc          ! Print control for debbuging
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2715)
@@ -16,8 +16,7 @@
    !!   trc_sbc      : update the tracer trend at ocean surface
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE oce_trc             ! ocean dynamics and active tracers variables
-   USE trc                 ! ocean  passive tracers variables
-   USE prtctl_trc          ! Print control for debbuging
+   USE oce_trc         ! ocean dynamics and active tracers variables
+   USE trc             ! ocean  passive tracers variables
+   USE prtctl_trc      ! Print control for debbuging
    USE trdmod_oce
    USE trdtra
@@ -26,6 +25,5 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC trc_sbc              ! routine called by step.F90
+   PUBLIC   trc_sbc   ! routine called by step.F90
 
    !! * Substitutions
@@ -34,7 +32,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -60,14 +57,18 @@
       !!
       !!----------------------------------------------------------------------
-      !! * Arguments
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zemps  => wrk_2d_1
+      USE wrk_nemo, ONLY:   ztrtrd => wrk_3d_1
+      !
       INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
-
-      !! * Local declarations
+      !
       INTEGER  ::   ji, jj, jn           ! dummy loop indices
       REAL(wp) ::   zsrau, zse3t   ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpj) ::   zemps  ! surface freshwater flux
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1) .OR.  wrk_in_use(3, 1) ) THEN
+         CALL ctl_stop('trc_sbc: requested workspace array unavailable.')   ;   RETURN
+      END IF
 
       IF( kt == nit000 ) THEN
@@ -77,6 +78,4 @@
       ENDIF
 
-
-      IF( l_trdtrc ) ALLOCATE( ztrtrd(jpi,jpj,jpk) )
 
       IF( lk_offline ) THEN          ! emps in dynamical files contains emps - rnf
@@ -113,10 +112,11 @@
       END DO                                                     ! tracer loop
       !                                                          ! ===========
-      IF( l_trdtrc ) DEALLOCATE( ztrtrd )
-
       IF( ln_ctl )   THEN
          WRITE(charout, FMT="('sbc ')") ;  CALL prt_ctl_trc_info(charout)
                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
+
+      IF( wrk_not_released(2, 1) .OR. wrk_not_released(3, 1) )   &
+      &       CALL ctl_stop('trc_sbc: failed to release workspace array.')
 
    END SUBROUTINE trc_sbc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2715)
@@ -11,5 +11,4 @@
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
    !!   trc_ldf     : update the tracer trend with the lateral diffusion
    !!       ldf_ctl : initialization, namelist read, and parameters control
@@ -20,19 +19,18 @@
    USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
    USE trazdf_imp      ! vertical diffusion: implicit (tra_zdf_imp     routine)
-   USE prtctl_trc      ! Print control
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE trdmod_oce
    USE trdtra
+   USE prtctl_trc      ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   trc_zdf    ! called by step.F90 
+   PUBLIC   trc_zdf          ! called by step.F90 
+   PUBLIC   trc_zdf_alloc    ! called by nemogcm.F90 
 
    INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
       !                                ! defined from ln_zdf...  namlist logicals)
-   REAL(wp), DIMENSION(jpk) ::  r2dt   ! vertical profile time-step, = 2 rdttra
-      !                                ! except at nit000 (=rdttra) if neuler=0
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  r2dt   ! vertical profile time-step, = 2 rdttra
+      !                                                 ! except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -43,9 +41,19 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
    
+   INTEGER FUNCTION trc_zdf_alloc()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_zdf_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( r2dt(jpk) , STAT=trc_zdf_alloc )
+      !
+      IF( trc_zdf_alloc /= 0 )   CALL ctl_warn('trc_zdf_alloc : failed to allocate array.')
+      !
+   END FUNCTION trc_zdf_alloc
+
+
    SUBROUTINE trc_zdf( kt )
       !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2715)
@@ -23,5 +23,5 @@
    USE zdfddm  , ONLY : avs  !: salinity vertical diffusivity coeff. at w-point
 # endif
-   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE trcnam_trp        ! passive tracers transport namelist variables
    USE trdmod_trc_oce    ! definition of main arrays used for trends computations
    USE in_out_manager    ! I/O manager
@@ -30,4 +30,5 @@
    USE ioipsl            ! NetCDF library
    USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp           ! MPP library
    USE trdmld_trc_rst    ! restart for diagnosing the ML trends
    USE prtctl            ! print control
@@ -39,4 +40,5 @@
 
    PUBLIC trd_mld_trc
+   PUBLIC trd_mld_trc_alloc
    PUBLIC trd_mld_bio
    PUBLIC trd_mld_trc_init
@@ -46,5 +48,5 @@
    CHARACTER (LEN=40) ::  clhstnam                                ! name of the trends NetCDF file
    INTEGER ::   nmoymltrd
-   INTEGER ::   ndextrd1(jpi*jpj)
+   INTEGER, ALLOCATABLE, SAVE, DIMENSION(:) ::   ndextrd1
    INTEGER, DIMENSION(jptra) ::   nidtrd, nh_t
    INTEGER ::   ndimtrd1                        
@@ -58,4 +60,11 @@
    LOGICAL :: lldebug = .TRUE.
 
+   ! Workspace array for trd_mld_trc() routine. Declared here as is 4D and
+   ! cannot use workspaces in wrk_nemo module.
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  ztmltrd2   !
+#if defined key_lobster
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  ztmltrdbio2  ! only needed for mean diagnostics in trd_mld_bio()
+#endif
+
    !! * Substitutions
 #  include "top_substitute.h90"
@@ -63,8 +72,23 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Header:  $ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
+
+   INTEGER FUNCTION trd_mld_trc_alloc()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_mld_trc_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( ztmltrd2(jpi,jpj,jpltrd_trc,jptra) ,      &
+#if defined key_lobster
+         &      ztmltrdbio2(jpi,jpj,jpdiabio)      ,      &
+#endif
+         &      ndextrd1(jpi*jpj)                  ,  STAT=trd_mld_trc_alloc)
+         !
+      IF( lk_mpp                )   CALL mpp_sum ( trd_mld_trc_alloc )
+      IF( trd_mld_trc_alloc /=0 )   CALL ctl_warn('trd_mld_trc_alloc: failed to allocate arrays')
+      !
+   END FUNCTION trd_mld_trc_alloc
+
 
    SUBROUTINE trd_mld_trc_zint( ptrc_trdmld, ktrd, ctype, kjn )
@@ -88,10 +112,16 @@
       !!            surface and the control surface is called "mixed-layer"
       !!----------------------------------------------------------------------
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zvlmsk => wrk_2d_1
+      !!
       INTEGER, INTENT( in ) ::   ktrd, kjn                        ! ocean trend index and passive tracer rank
       CHARACTER(len=2), INTENT( in ) ::  ctype                    ! surface/bottom (2D) or interior (3D) physics
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::  ptrc_trdmld ! passive tracer trend
       INTEGER ::   ji, jj, jk, isum
-      REAL(wp), DIMENSION(jpi,jpj) ::  zvlmsk
-      !!----------------------------------------------------------------------
+      !!----------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1) ) THEN
+         CALL ctl_stop('trd_mld_trc_zint: requested workspace array unavailable')   ;   RETURN
+      ENDIF
 
       ! I. Definition of control surface and integration weights
@@ -177,8 +207,11 @@
             tmltrd_trc(:,:,ktrd,kjn) = tmltrd_trc(:,:,ktrd,kjn) + ptrc_trdmld(:,:,1) * wkx_trc(:,:,1)  ! non penetrative
       END SELECT
-
-    END SUBROUTINE trd_mld_trc_zint
-    
-    SUBROUTINE trd_mld_bio_zint( ptrc_trdmld, ktrd )
+      !
+      IF( wrk_not_released(2, 1) )   CALL ctl_stop('trd_mld_trc_zint: failed to release workspace array')
+      !
+   END SUBROUTINE trd_mld_trc_zint
+
+
+   SUBROUTINE trd_mld_bio_zint( ptrc_trdmld, ktrd )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mld_bio_zint  ***
@@ -198,11 +231,17 @@
       !!            surface and the control surface is called "mixed-layer"
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   ktrd          ! bio trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::  ptrc_trdmld ! passive trc trend
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zvlmsk => wrk_2d_1
+      !!
+      INTEGER                         , INTENT(in) ::   ktrd          ! bio trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) ::   ptrc_trdmld   ! passive trc trend
 #if defined key_lobster
-      !! local variables
+      !
       INTEGER ::   ji, jj, jk, isum
-      REAL(wp), DIMENSION(jpi,jpj) ::  zvlmsk
-      !!----------------------------------------------------------------------
+      !!----------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1) ) THEN
+         CALL ctl_stop('trd_mld_bio_zint: requested workspace array unavailable')   ;   RETURN
+      ENDIF
 
       ! I. Definition of control surface and integration weights
@@ -286,10 +325,11 @@
       END DO
 
-#endif
-
-    END SUBROUTINE trd_mld_bio_zint
-
-
-    SUBROUTINE trd_mld_trc( kt )
+      IF( wrk_not_released(2, 1) )   CALL ctl_stop('trd_mld_bio_zint: failed to release workspace array')
+#endif
+      !
+   END SUBROUTINE trd_mld_bio_zint
+
+
+   SUBROUTINE trd_mld_trc( kt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mld_trc  ***
@@ -338,20 +378,25 @@
       !!       - See NEMO documentation (in preparation)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt                               ! ocean time-step index
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   wrk_3d_1, wrk_3d_2, wrk_3d_3, wrk_3d_4
+      USE wrk_nemo, ONLY:   wrk_3d_5, wrk_3d_6, wrk_3d_7, wrk_3d_8, wrk_3d_9
+      !
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !
       INTEGER ::   ji, jj, jk, jl, ik, it, itmod, jn
       REAL(wp) ::   zavt, zfn, zfn2
-      !!
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltot             ! d(trc)/dt over the anlysis window (incl. Asselin)
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlres             ! residual = dh/dt entrainment term
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlatf             ! for storage only
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlrad             ! for storage only (for trb<0 corr in trcrad)
-      !!
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltot2            ! -+
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlres2            !  | working arrays to diagnose the trends
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmltrdm2           !  | associated with the time meaned ML
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlatf2            !  | passive tracers
-      REAL(wp), DIMENSION(jpi,jpj,jptra) ::   ztmlrad2            !  | (-> for trb<0 corr in trcrad)
-      REAL(wp), DIMENSION(jpi,jpj,jpltrd_trc,jptra) ::  ztmltrd2  ! -+
-      !!
+      !
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot             ! d(trc)/dt over the anlysis window (incl. Asselin)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres             ! residual = dh/dt entrainment term
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf             ! for storage only
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad             ! for storage only (for trb<0 corr in trcrad)
+      !
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot2            ! -+
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres2            !  | working arrays to diagnose the trends
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltrdm2           !  | associated with the time meaned ML
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf2            !  | passive tracers
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad2            !  | (-> for trb<0 corr in trcrad)
+      !REAL(wp), DIMENSION(jpi,jpj,jpltrd_trc,jptra) ::  ztmltrd2  ! -+
+      !
       CHARACTER (LEN= 5) ::   clvar
 #if defined key_dimgout
@@ -361,5 +406,20 @@
       !!----------------------------------------------------------------------
 
-      IF( nn_dttrc  /= 1  ) CALL ctl_stop( " Be careful, trends diags never validated " )
+      IF( wrk_in_use(3, 1,2,3,4,5,6,7,8,9) ) THEN
+         CALL ctl_stop('trd_mld_trc : requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
+      ! Set-up pointers into sub-arrays of workspaces
+      ztmltot   => wrk_3d_1(:,:,1:jptra)
+      ztmlres   => wrk_3d_2(:,:,1:jptra)
+      ztmlatf   => wrk_3d_3(:,:,1:jptra)
+      ztmlrad   => wrk_3d_4(:,:,1:jptra)
+      ztmltot2  => wrk_3d_5(:,:,1:jptra)
+      ztmlres2  => wrk_3d_6(:,:,1:jptra)
+      ztmltrdm2 => wrk_3d_7(:,:,1:jptra)
+      ztmlatf2  => wrk_3d_8(:,:,1:jptra)
+      ztmlrad2  => wrk_3d_9(:,:,1:jptra)
+
+
+      IF( nn_dttrc  /= 1  )   CALL ctl_stop( " Be careful, trends diags never validated " )
 
       ! ======================================================================
@@ -386,5 +446,5 @@
 
          DO jn = 1, jptra
-         ! ... Remove this K_z trend from the iso-neutral diffusion term (if any)
+            ! ... Remove this K_z trend from the iso-neutral diffusion term (if any)
             IF( ln_trdtrc(jn) ) &
                  tmltrd_trc(:,:,jpmld_trc_ldf,jn) = tmltrd_trc(:,:,jpmld_trc_ldf,jn) - tmltrd_trc(:,:,jpmld_trc_zdf,jn)
@@ -847,7 +907,10 @@
       IF( lrst_trc )   CALL trd_mld_trc_rst_write( kt )  ! this must be after the array swap above (III.3)
 
+      IF( wrk_not_released(3, 1,2,3,4,5,6,7,8,9) )   CALL ctl_stop('trd_mld_trc: failed to release workspace arrays')
+      !
    END SUBROUTINE trd_mld_trc
 
-    SUBROUTINE trd_mld_bio( kt )
+
+   SUBROUTINE trd_mld_bio( kt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mld  ***
@@ -900,5 +963,4 @@
       INTEGER  ::  jl, it, itmod
       LOGICAL  :: llwarn  = .TRUE., lldebug = .TRUE.
-      REAL(wp), DIMENSION(jpi,jpj,jpdiabio) ::  ztmltrdbio2  ! only needed for mean diagnostics
       REAL(wp) :: zfn, zfn2
 #if defined key_dimgout
@@ -1085,4 +1147,5 @@
    END SUBROUTINE trd_mld_bio
 
+
    REAL FUNCTION sum2d( ztab )
       !!----------------------------------------------------------------------
@@ -1091,6 +1154,7 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT( in ) ::  ztab      
       !!----------------------------------------------------------------------
-      sum2d = SUM(ztab(2:jpi-1,2:jpj-1))
+      sum2d = SUM( ztab(2:jpi-1,2:jpj-1) )
    END FUNCTION sum2d
+
 
    SUBROUTINE trd_mld_trc_init
@@ -1378,17 +1442,13 @@
    !!   Default option :                                       Empty module
    !!----------------------------------------------------------------------
-
 CONTAINS
-
    SUBROUTINE trd_mld_trc( kt )                                   ! Empty routine
       INTEGER, INTENT( in) ::   kt
       WRITE(*,*) 'trd_mld_trc: You should not have seen this print! error?', kt
    END SUBROUTINE trd_mld_trc
-
    SUBROUTINE trd_mld_bio( kt )
       INTEGER, INTENT( in) ::   kt
       WRITE(*,*) 'trd_mld_bio: You should not have seen this print! error?', kt
    END SUBROUTINE trd_mld_bio
-
    SUBROUTINE trd_mld_trc_zint( ptrc_trdmld, ktrd, ctype, kjn )
       INTEGER               , INTENT( in ) ::  ktrd, kjn              ! ocean trend index and passive tracer rank
@@ -1400,5 +1460,4 @@
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', kjn
    END SUBROUTINE trd_mld_trc_zint
-
    SUBROUTINE trd_mld_trc_init                                    ! Empty routine
       WRITE(*,*) 'trd_mld_trc_init: You should not have seen this print! error?'
